// ANCHOR: here
fn first_word(s: &str) -> &str {
    // ANCHOR_END: here
    let bytes = s.as_bytes();

    for (i, &item) in bytes.iter().enumerate() {
        if item == b' ' {
            return &s[0..i];
        }
    }

    &s[..]
}

// ANCHOR: usage
fn main() {
    let my_string = String::from("witaj świecie");

    // `first_word` działa na wycinkach `String, zarówno częściowych, jak i całych
    let word = first_word(&my_string[0..6]);
    let word = first_word(&my_string[..]);
    // `first_word` działa także na referencjach do `String`, które są
    // równoważne z całymi wycinkami `String`
    let word = first_word(&my_string);

    let my_string_literal = "witaj świecie";

    // `first_word` działa na wycinkach literałów łańcuchów znaków, zarówno częściowych, jak i całych
    let word = first_word(&my_string_literal[0..6]);
    let word = first_word(&my_string_literal[..]);

    // Ponieważ literały łańcuchów znaków *są* już wycinkami łańcuchów znaków,
    // to również działa bez konieczności stosowania składni wycinków!
    let word = first_word(my_string_literal);
}
// ANCHOR_END: usage
